-- $Id: Add1ListTests.hs,v 1.3 2013/01/27 19:01:02 leavens Exp leavens $
module Add1ListTests where
import Testing
import Add1List  -- you have to put your solutions in module Add1List

version = "Add1ListTests $Revision: 1.3 $"
recursive_tests = (tests add1_list_rec)
comprehension_tests = (tests add1_list_comp)

-- do main to run our tests
main :: IO()
main = do startTesting version
          errs_comp <- run_test_list 0 comprehension_tests
          total_errs <- run_test_list errs_comp recursive_tests
          doneTesting total_errs

-- do test_comprehension to test just add1_list_comp
test_comprehension :: IO()
test_comprehension = dotests version comprehension_tests

-- do test_recursive to test just add1_list_rec
test_recursive :: IO()
test_recursive = dotests version recursive_tests

tests :: ([Integer] -> [Integer]) -> [TestCase [Integer]]
tests f = 
    [(eqTest (f []) "==" [])
    ,(eqTest (f (1:[])) "==" (2:[]))
    ,(eqTest (f (3:1:[])) "==" (4:2:[]))
    ,(eqTest (f [1,5,7,1,7]) "==" [2,6,8,2,8])
    ,(eqTest (f [5 .. 20]) "==" [6 .. 21])
    ,(eqTest (f [9,5,-3,4,2,99999999,10])
           "==" [10,6,-2,5,3,100000000,11])
    ]
