-- $Id: ChangeChannelTests.hs,v 1.2 2013/01/28 02:49:56 leavens Exp leavens $
module ChangeChannelTests where
import WindowLayout
import qualified Data.Set as HSet
import ChangeChannel
import Testing

main = dotests "ChangeChannelTests $Revision: 1.2 $" tests

tests :: [TestCase WindowLayout]
tests = 
 [(eqTest (changeChannel "goldfinger" "olympics" 
                         (Window {wname = "olympics", width = 50, height = 33}))
   "==" (Window {wname = "goldfinger", width = 50, height = 33}))
 ,(eqTest (changeChannel "masterpiece" "dancing" (Horizontal [])) "==" (Horizontal []))
 ,(eqTest (changeChannel "nova" "Star Trek" (Vertical [])) "==" (Vertical []))
 ,(eqTest (changeChannel "masterpiece" "local news"
            (Horizontal [(Window {wname = "olympics", width = 80, height = 33})
                        ,(Window {wname = "local news", width = 20, height = 10})]))
   "==" (Horizontal [(Window {wname = "olympics", width = 80, height = 33})
                    ,(Window {wname = "masterpiece", width = 20, height = 10})]))
 ,(eqTest (changeChannel "Dr. No" "olympics"
           (Vertical [(Window {wname = "olympics", width = 80, height = 33})
                     ,(Window {wname = "local news", width = 20, height = 10})]))
   "==" (Vertical [(Window {wname = "Dr. No", width = 80, height = 33})
                  ,(Window {wname = "local news", width = 20, height = 10})]))
 ,(eqTest (changeChannel "Sienfeld" "local news"
           (Vertical [(Window {wname = "Star Trek", width = 40, height = 100})
                    ,(Window {wname = "olympics", width = 80, height = 33})
                    ,(Window {wname = "Sienfeld", width = 20, height = 10})]))
   "==" (Vertical [(Window {wname = "Star Trek", width = 40, height = 100})
                  ,(Window {wname = "olympics", width = 80, height = 33})
                  ,(Window {wname = "Sienfeld", width = 20, height = 10})]))
 ,(eqTest (changeChannel "Sienfeld" "local news"
         (Horizontal 
            [(Vertical [(Window {wname = "Tempest", width = 200, height = 100})
                      ,(Window {wname = "Othello", width = 200, height = 77})
                      ,(Window {wname = "Hamlet", width = 1000, height = 600})])
            ,(Horizontal [(Window {wname = "baseball", width = 50, height = 40})
                        ,(Window {wname = "local news", width = 100, height = 60})
                        ,(Window {wname = "equestrian", width = 70, height = 30})])
            ,(Vertical [(Window {wname = "Star Trek", width = 40, height = 100})
                      ,(Window {wname = "olympics", width = 80, height = 33})
                      ,(Window {wname = "local news", width = 20, height = 10})])
            ]))
   "==" (Horizontal 
            [(Vertical [(Window {wname = "Tempest", width = 200, height = 100})
                      ,(Window {wname = "Othello", width = 200, height = 77})
                      ,(Window {wname = "Hamlet", width = 1000, height = 600})])
            ,(Horizontal [(Window {wname = "baseball", width = 50, height = 40})
                        ,(Window {wname = "Sienfeld", width = 100, height = 60})
                        ,(Window {wname = "equestrian", width = 70, height = 30})])
            ,(Vertical [(Window {wname = "Star Trek", width = 40, height = 100})
                      ,(Window {wname = "olympics", width = 80, height = 33})
                      ,(Window {wname = "Sienfeld", width = 20, height = 10})])
            ])) ]
