-- $Id: DeleteAllTests.hs,v 1.2 2013/01/27 02:49:08 leavens Exp leavens $
module DeleteAllTests where
import Testing
import DeleteAll  -- you have to put your solutions in this module

version = "DeleteAllTests $Revision: 1.2 $"
recursive_tests = (tests deleteAll_list_rec)
comprehension_tests = (tests deleteAll_list_comp)

-- do main to run our tests
main :: IO()
main = do startTesting version
          errs_comp <- run_test_list 0 comprehension_tests
          total_errs <- run_test_list errs_comp recursive_tests
          doneTesting total_errs

-- do test_comprehension to test just deleteAll_list_comp
test_comprehension :: IO()
test_comprehension = dotests version comprehension_tests

-- do test_recursive to test just deleteAll_list_rec
test_recursive :: IO()
test_recursive = dotests version recursive_tests

tests :: (Int -> ([Int] -> [Int])) -> [TestCase [Int]]
tests f = 
    [(eqTest (f 3 []) "==" [])
    ,(eqTest (f 3 (1:[])) "==" (1:[]))
    ,(eqTest (f 1 (1:[])) "==" [])
    ,(eqTest (f 3 (3:1:[])) "==" (1:[]))
    ,(eqTest (f 1 (3:1:[])) "==" (3:[]))
    ,(eqTest (f 7 (3:1:[])) "==" (3:1:[]))
    ,(eqTest (f 7 [1,5,7,1,7]) "==" [1,5,1])
    ,(eqTest (f 1 [1,5,7,1,7]) "==" [5,7,7])
    ,(eqTest (f 20 ([1 .. 50] ++ (reverse [1 .. 50]))) 
      "==" (let out = [1 .. 19] ++ [21 .. 50] in (out ++ (reverse out))))
    ]
