-- $Id: WatchingTests.hs,v 1.1 2013/01/27 19:01:02 leavens Exp $
module WatchingTests where
import WindowLayout
import qualified Data.Set as HSet
import Watching
import Testing

main = dotests "WatchingTests $Revision: 1.1 $" tests

tests :: [TestCase (HSet.Set String)]
tests = 
 [(eqTest (watching (Window {wname = "olympics", width = 50, height = 33}))
          "==" (HSet.singleton "olympics"))
 ,(eqTest (watching (Horizontal [])) "==" HSet.empty)
 ,(eqTest (watching (Vertical [])) "==" HSet.empty)
 ,(eqTest (watching
            (Horizontal [(Window {wname = "olympics", width = 80, height = 33})
                        ,(Window {wname = "local news", width = 20, height = 10})]))
   "==" ((HSet.singleton "olympics") `HSet.union` (HSet.singleton "local news")))
 ,(eqTest (watching
           (Vertical [(Window {wname = "olympics", width = 80, height = 33})
                     ,(Window {wname = "local news", width = 20, height = 10})]))
   "==" ((HSet.singleton "olympics") `HSet.union` (HSet.singleton "local news")))
 ,(eqTest (watching
           (Vertical [(Window {wname = "Star Trek", width = 40, height = 100})
                    ,(Window {wname = "olympics", width = 80, height = 33})
                    ,(Window {wname = "local news", width = 20, height = 10})]))
   "==" ((HSet.singleton "Star Trek") `HSet.union` (HSet.singleton "olympics")
         `HSet.union` (HSet.singleton "local news")))
 ,(eqTest (watching
         (Horizontal 
            [(Vertical [(Window {wname = "Tempest", width = 200, height = 100})
                      ,(Window {wname = "Othello", width = 200, height = 77})
                      ,(Window {wname = "Hamlet", width = 1000, height = 600})])
            ,(Horizontal [(Window {wname = "baseball", width = 50, height = 40})
                        ,(Window {wname = "track", width = 100, height = 60})
                        ,(Window {wname = "equestrian", width = 70, height = 30})])
            ,(Vertical [(Window {wname = "Star Trek", width = 40, height = 100})
                      ,(Window {wname = "olympics", width = 80, height = 33})
                      ,(Window {wname = "local news", width = 20, height = 10})])
            ]))
   "==" ((HSet.unions 
          (map HSet.singleton ["Tempest","Othello","Hamlet","baseball","track"
                              ,"equestrian","Star Trek","olympics","local news"]))))
 ]
